#include <stdio.h>
#include <string.h>

int of_prior(char ch) { return ch >= 'a' && ch <= 'z'; };
int of_after(char ch) { return ch >= 'A' && ch <= 'Z'; };


char *find_end(int (*of)(char), char *s, char *e)
{
    char *p = s;
    int l = e - s;
    while (l && of(*p)) l--, p++;
    if (l) return p;
    return e;
}


void shift(char *s, char *e)
{
    e -= 1;
    for (; s < e; s++, e--) {
        char t = *e;
        *e = *s;
        *s = t;
    }
}


int sort_cap(char *s, char *e)
{
    s = find_end(of_prior, s, e);
    if (s == e) return -1;
    for (;;) {
        char *m = find_end(of_after, s, e);
        if (m == e) return 0;
        char *n = find_end(of_prior, m, e);
        shift(s, m);
        shift(m, n);
        shift(s, n);
        s += n - m;
    }
}


void direct_method(char *s, char *e)
{
    char *cap = e;
    char *p = e - 1;
    for (; p >= s; p--) {
        if (of_after(*p)) {
            char *q = p;
            for (; q < cap - 1; q++) {
                char t = *q;
                *q = q[1];
                q[1] = t;
            }
            cap -= 1;
        }
    }
}


void dual_print(char *str, int len)
{
    int i;
    for (i = 0; i < len; i++) if (of_prior(str[i])) putchar(str[i]);
    for (i = 0; i < len; i++) if (of_after(str[i])) putchar(str[i]);
    printf("\n");
}


int main()
{
    char buf[] = "AklBiCeilD";
    //direct_method(buf, buf + strlen(buf));
    sort_cap(buf, buf + strlen(buf));
    printf("%s\n", buf);
    //dual_print(buf, strlen(buf));
    return 0;
}
